''
'' Copyright 2005-2008 the Seasar Foundation and the Others.
''
'' Licensed under the Apache License, Version 2.0 (the "License");
'' you may not use this file except in compliance with the License.
'' You may obtain a copy of the License at
''
''     http://www.apache.org/licenses/LICENSE-2.0
''
'' Unless required by applicable law or agreed to in writing, software
'' distributed under the License is distributed on an "AS IS" BASIS,
'' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
'' either express or implied. See the License for the specific language
'' governing permissions and limitations under the License.
''
Imports Seasar.Quill.Attrs
Imports Seasar.S2FormExample.Logics.Dto
Imports Seasar.S2FormExample.Logics.Page
Imports Seasar.S2FormExample.Logics.Dao

Namespace Service.Impl
    ''' <summary>
    ''' Јo^pT[rXpNX
    ''' </summary>
    ''' <remarks></remarks>
    Public Class EmployeeEditServiceImpl
        Inherits BaseServiceImpl
        Implements IEmployeeEditService

        Protected dao As IEmployeeDao

        ''' <summary>
        ''' RXgN^
        ''' </summary>
        ''' <remarks></remarks>
        Public Sub New()
            '
        End Sub

        ''' <summary>
        ''' Јf[^폜
        ''' </summary>
        ''' <param name="id"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        <Transaction()> _
        Public Function ExecDelete(ByVal id As Integer) As Integer Implements IEmployeeEditService.ExecDelete
            Dim dto As New EmployeeDto
            dto.Id = id

            Return dao.DeleteData(dto)
        End Function

        ''' <summary>
        ''' Јf[^o^
        ''' </summary>
        ''' <param name="data"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        <Transaction()> _
        Public Function ExecUpdate(ByVal data As EmployeeEditPage) As Integer _
            Implements IEmployeeEditService.ExecUpdate
            If data Is Nothing = True Then
                Throw New ArgumentNullException("data")
            End If

            Dim dto As New EmployeeDto
            dto.Code = data.Code
            dto.DeptNo = data.Depart
            dto.EntryDay = data.Entry
            dto.Gender = data.Gender
            dto.Id = data.Id
            dto.Name = data.Name

            If dto.Id.HasValue = True Then
                Dim e1 As EmployeeDto = dao.GetData(dto.Id)
                If e1 Is Nothing = False Then
                    Return dao.UpdateData(dto)
                Else
                    Return dao.InsertData(dto)
                End If
            Else
                Return dao.InsertData(dto)
            End If

        End Function

        ''' <summary>
        ''' Јf[^擾
        ''' </summary>
        ''' <param name="id">ЈID</param>
        ''' <returns>Јf[^</returns>
        ''' <remarks></remarks>
        Public Function GetData(ByVal id As Integer) As EmployeeEditPage Implements IEmployeeEditService.GetData
            Dim page As EmployeeEditPage = New EmployeeEditPage()
            Dim dto As EmployeeDto = dao.GetData(id)
            If dto Is Nothing = False Then
                page.Code = dto.Code
                page.Depart = dto.DeptNo
                page.Entry = dto.EntryDay
                page.Gender = dto.Gender
                page.Id = dto.Id
                page.Name = dto.Name
            Else
                page = Nothing
            End If

            Return page
        End Function
    End Class
End Namespace